import es
import gamethread
import advertlib

import base64
import collections


#################################################
                #Start Config Box


message_system = 1

# If you want to allow infinite queue length, set this value to None.
max_queue_length = 3

                #End Config box
#################################################


# Please do not edit below this line

info = es.AddonInfo()
info.esamname = 'easychange'
info.name = 'EasyChange'
info.version = '2.0.0'
info.author = 'Brainsucker'
info.url = 'http://addons.eventscripts.com/addons/view/%s' % info.esamname

adv = advertlib.ChatAdvert('easychange_command', '#defaultType $color!team $colorin the Chat to change the team with another player.')
adv.colors = ('#green', '#default')
adv.enabled = True


class TeamQueue(collections.deque):
    def __init__(self, iterable=(), maxlen=None):
        collections.deque().__init__(iterable)
        self.maxlen = maxlen
    def full(self):
        return len(self) == self.maxlen
        
    def empty(self):
        return len(self) == 0
        
ct_queue = TeamQueue(maxlen=max_queue_length)

t_queue = TeamQueue(maxlen=max_queue_length)


message_tag = '#green[#lightgreen%s#green] ' % info.name

# Wrapping Function
def sendMSG(text):
    es.msg('#multi', message_tag + text)
    
def load():
    if info.author == base64.decodestring('QnJhaW5zdWNrZXI=\n'):
        es.ServerVar(info.name, '%s by %s' % (info.version, info.author)).makepublic()
        if message_system:
            sendMSG('loaded!')


def player_say(ev):
    uid = ev['userid']
    ut = ev['es_userteam']
    if ev['text'].lower() == '!team':
        was_added = False
        queue_full = False
        if ut == '2':
            if not t_queue.full():
                was_added = True
                t_queue.append(uid)
                
            else:
                queue_full = True
                
        elif ut == '3':
            if not t_queue.full():
                was_added = True
                ct_queue.append(uid)
            else:
                queue_full = True
                
                
        if was_added:
            if message_system:
                sendMSG('#lightgreen%s #defaultwants to change the Team.' % ev['es_username'])
            es.tell(uid, '#multi', 'You have been added to the queue.')
        
        if queue_full:
            es.tell(uid, '#multi', 'Sorry, the queue is already full. Please try again later.')

def round_end(ev):
    if not t_queue.empty() and not ct_queue.empty():
        if message_system:
            sendMSG('Processing team changes...')
    while True:
        if t_queue.empty():
            break
        if ct_queue.empty():
            break
            
        t_player = t_queue.popleft()
        ct_player = ct_queue.popleft()
        for x in (t_player, ct_player):
            es.server.queuecmd('es_xchangeteam %s 1' % x)
        gamethread.delayed(0.5, es.server.queuecmd, ('es_xchangeteam %s 2' % ct_player))
        gamethread.delayed(0.5, es.server.queuecmd, ('es_xchangeteam %s 3' % t_player))
        
def es_map_start(ev):
    t_queue.clear()
    ct_queue.clear()

def player_disconnect(ev):
    uid = ev['userid']
    if uid in t_queue:
        t_queue.remove(uid)
        
    if uid in ct_queue:
        ct_queue.remove(uid)
        
def unload():
    global adv
    adv.unregister()
    if message_system:
        sendMSG('unloaded!')